<?php

function quiz_body_creater($atts){
	global $wpdb;
	$wpdb->show_errors(); 
	if($atts["id"]<1) {
		echo "Quiz is not selected! Please, read Readme.txt";
		return;
	}
	$session=rand();
	$quiz_title = $wpdb->get_var("SELECT title FROM ssquiz_quizzes WHERE id='" . $atts["id"] . "'");
	$quiz_description = $wpdb->get_var("SELECT description FROM ssquiz_quizzes WHERE id='" . $atts["id"] . "'");
	$total = $wpdb->get_var("SELECT COUNT(*) FROM ssquiz_questions WHERE quiz_id='" . $atts["id"] . "' AND number!=99999");
	if(in_array("not_correct", $atts)) set_transient('not_correct_answers'.$session, 'true', 9999);
	if(in_array("all", $atts)) set_transient('all_questions'.$session, 'true', 9999);
	if(in_array("qrandom", $atts)) set_transient('qrandom'.$session, 'true', 9999);
	if(in_array("arandom", $atts)) set_transient('arandom'.$session, 'true', 9999);
	if(in_array("email", $atts)) set_transient('email'.$session, 'true', 9999);
	if(in_array("name", $atts)) set_transient('name'.$session, 'true', 9999);
	if($atts["timer"]>0) set_transient('timer'.$session, 'true', 9999);
	set_transient('quiz_id'.$session, $atts["id"], 9999);
	set_transient('quiz_title'.$session, $quiz_title, 9999);
	set_transient('quiz_description'.$session, $quiz_description, 9999);
	set_transient('questions_counter'.$session, -1, 9999);
	set_transient('questions_right'.$session, 0, 9999);
	set_transient('total_questions'.$session, $total, 9999);
	set_transient('answer_sheet'.$session, array());
	
	$welcome = $wpdb->get_var("SELECT value FROM ssquiz_settings WHERE name='start_screen'");
	$welcome = str_replace("%%TITLE%%", $quiz_title, $welcome);
	$welcome = str_replace("%%DESCRIPTION%%", $quiz_description, $welcome);
	$welcome = str_replace("%%QUESTIONS%%", $total, $welcome);
	?>
    <div class="quiz" id="<? echo $session;?>">

	<? 
	if(get_transient("timer".$session)) {
		echo '<em><div class="sstimer"><span>Seconds left:</span><span id="sstimer">'.$atts['timer'].'</span></div></em>';
    }
	?>
	
    <h2 align='center'><? echo $quiz_title; ?></h2>
	<div class="quiz_area">
	<? echo stripslashes(html_entity_decode($welcome)); ?>
    <? echo stripslashes(html_entity_decode($myrows)) ?>
    <br />
    <br />
    <? 
	if(get_transient("name".$session)) {
		echo '<label for="user_name">Name: </label>';
    	echo '<input type="text" id="user_name" name="user_name" value="" />';
		echo '<br />';
    }
	if(get_transient("email".$session)) {
    	echo '<label for="email">E-Mail: </label> ';
    	echo '<input type="text"  id="email" name="email" value="" />';
    } ?>
	</div>
	
	<div class="sshistory"></div>
	
    <button class="start" id="next_button">OK</button>
    <button class="exit_but" id="exit_but" style="display:none">Exit</button>
    </div>
 	<?php
}

function tag_replace($result, $session) {
	$temp_var=intval(get_transient('total_questions'.$session));
	if($temp_var==0) $temp_var=-1;
	$percent=intval(strval(100*intval(get_transient('questions_right'.$session))/$temp_var));
	$result=str_replace("%%TITLE%%", get_transient('quiz_title'.$session), $result);
	$result=str_replace("%%DESCRIPTION%%", get_transient('quiz_description'.$session), $result);
	$result=str_replace("%%TOTAL%%", get_transient('total_questions'.$session), $result);
	$result=str_replace("%%CORRECT%%", get_transient('questions_right'.$session), $result);
	$result=str_replace("%%PERCENT%%", $percent, $result);
	return $result;
}

function exit_quiz($session=0, $button_clicked=true){
		global $wpdb;
		$wpdb->show_errors(); 
		if(isset($_POST["session"]))
			$session=intval($_POST["session"]);
		$result = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='result_screen' LIMIT 1");
		echo '<script>document.getElementById("next_button").style.display="none";document.getElementById("exit_but").style.display="none";clearTimeout(timer1); </script>';
		if(isset($_POST['question_id']) && $button_clicked){
			next_question(true);
		}
		echo stripslashes(html_entity_decode(tag_replace($result, $session)));

		if(get_transient('not_correct_answers'.$session)==false){
	/*		echo '<pre>';
			var_dump(get_transient('answer_sheet'.$session));
			echo '</pre>';*/
			$answer_sheet=get_transient('answer_sheet'.$session);
			//echo '<div class="answer_sheet">';
			echo '</br>';
			foreach($answer_sheet as $name=>$value) {
				if($value["correct"])
					echo '<a href="#" class="ssanswer_history" style="color:green" id="'.$value["question_id"].'">'.$name.'</a> ';
				else
					echo '<a href="#" class="ssanswer_history" style="color:red" id="'.$value["question_id"].'">'.$name.'</a> ';
			}
			//echo '</div>';
		}
		if(get_transient("email".$session)) {
			$email = $wpdb->get_var( "SELECT value FROM ssquiz_settings WHERE name='email_screen' LIMIT 1");
			$message = stripslashes(html_entity_decode(tag_replace($email, $session)));
			wp_mail(get_transient('user_email'.$session), 'Quiz', $message);
		}

		$wpdb->insert("ssquiz_users", 
			array('user_name'=>get_transient('user_name'.$session), 
			'user_email'=>get_transient('user_email'.$session), 
			'answered'=>get_transient('questions_counter'.$session), 
			'correct'=>get_transient('questions_right'.$session),
			'quiz'=>get_transient('quiz_title'.$session)));
		die();
}

function draw_history($number, $session){
	global $wpdb;
	$wpdb->show_errors();
	
	$temp=get_transient('answer_sheet'.$session);
	$question = $wpdb->get_var("SELECT question FROM ssquiz_questions WHERE id=".$temp[$number]["question_id"]);
	$correct = $wpdb->get_col("SELECT answer FROM ssquiz_answers WHERE question_id='".$temp[$number]["question_id"]."' AND correct='1'");
	
	echo '<div class="question"><strong>Question #'.$number.':</strong><br  />'; 
	echo stripslashes(stripslashes(html_entity_decode($question))); 
	echo '</div><br />';
	
	echo '<font color="green">Correct answer: '.implode(" ", $correct). '</font><br/>';
	if($temp[$number]["correct"]==false){
		if(strlen($temp[$number]["answer"])>0)
			echo '<font color="red">Your answer: '.$temp[$number]["answer"]. '</font>';
		else
			echo '<font color="red">You didn\'t answer to this question.</font>';
	}
	else
		echo '<font color="green">You were right!</font>';
}

function view_answer() {
	$session=intval($_POST["session"]);
	$option=intval($_POST["option"]);

	if($option==-1)
		$number=get_transient("history_view".$session)-1;
	else if ($option==-2)
		$number=get_transient("history_view".$session)+1;
	else if ($option>0)
		$number=$option;
	 else
		die("Internal error 45");
	set_transient("history_view".$session, $number, 9999);
	draw_history($number, $session);
	echo '<br /><center>';
	if($number>1)
		echo '<a class="ssanswer_history prev"><<</a>';
	echo '<a class="ssback">Back</a>';
	if($number<get_transient('questions_counter'.$session))
		echo '<a class="ssanswer_history forw">>></a>';
	echo '</center>';
	die();
}

function do_all(){
		global $wpdb;
		$wpdb->show_errors();
		$session=intval($_POST["session"]);
		$temps=array();
		$answer_sheet=array();
		$counter=1;
		foreach ($_POST["answers"] as $answer) {
			if(!isset($temps[$answer['name']])) $temps[$answer['name']]=array();
			array_push($temps[$answer['name']], $answer['value']);
		}
		foreach ($temps as $name=>$value) {
				$answer_sheet[$counter]["question_id"]=$name;
				$answer_sheet[$counter]["answer"]=implode("|", $value);
				$answer_sheet[$counter]["correct"]=false;
				$row = $wpdb->get_col("SELECT answer FROM ssquiz_answers WHERE question_id='". $name ."' AND correct='1'");
				if($row==$value){
					set_transient('questions_right'.$session, get_transient('questions_right'.$session)+1, 9999);
					$answer_sheet[$counter]["correct"]=true;
				}
				$counter++;
			}

		set_transient('answer_sheet'.$session, $answer_sheet, 9999);
		exit_quiz($session);
		die();
}

function start_quiz(){
		$session=intval($_POST["session"]);
		$user_email=stripslashes(esc_attr(strip_tags($_POST["user_email"])));
		$user_name=stripslashes(esc_attr(strip_tags($_POST["user_name"])));
		set_transient('user_email'.$session, $user_email, 9999);
		set_transient('user_name'.$session, $user_name, 9999);
		echo 'TEST STARTED';
		die();
}

function all_questions($session){
		global $wpdb;
		$wpdb->show_errors();
		$questions = $wpdb->get_results("SELECT * FROM ssquiz_questions WHERE quiz_id='".get_transient('quiz_id'.$session)."' AND number!=99999 ORDER BY number");
		set_transient('questions_counter'.$session, count($questions), 9999);
		$qconter=1;
		echo '<script>document.getElementById("exit_but").style.display="none";</script>';
		if ($questions== NULL){
			echo '<script>document.getElementById("next_button").style.display="none";</script>';
			die("There is no tests in quiz <strong>". get_transient('quiz_title'.$session)."</strong>");
		}
		if(get_transient('qrandom'.$session)=='true')
			shuffle($questions);

		foreach($questions as $question){
			$question=get_object_vars($question);
			$answers = $wpdb->get_results( "SELECT * FROM ssquiz_answers WHERE question_id=" . $question['id']);
			$correct = $wpdb->get_var("SELECT COUNT(*) FROM ssquiz_answers WHERE question_id='".$question['id']."' AND correct='1'");
			
			echo '<div class="question_body">';
			echo '<div class="question"><strong>Question #' . $qconter++ . ':</strong><br  />';
			echo stripslashes(stripslashes(html_entity_decode($question['question']))); 
			//set_transient('questions_counter'.$session, get_transient('questions_counter'.$session)+1, 9999);
			echo '</div><br />';
        	//--------checking for multianswer test
			if(count($answers)>1) {
				if(get_transient('arandom'.$session)=='true') 
					shuffle($answers);
				set_transient('answer'.$session, "", 9999);
				foreach($answers as $answer) {
					$answer=get_object_vars($answer);
					if($correct>1)
						echo '<input type="checkbox" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
					else
						echo '<input type = "radio" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
					
					if($answer['correct']=='1')
						set_transient('answer'.$session, get_transient('answer'.$session)."|".$answer['answer'], 9999);
				}
			//var_dump(get_transient('answer'.$session));
			}
			else 
				echo '<input type="text" class="answer" name="'.$question['id'].'" value=""  />';

			echo '</div>';
			if($question!=end($questions))
				echo '<hr /><br />';
        }
		die();
}

function next_question($last=false){
		global $wpdb;
		$wpdb->show_errors();
		$session=intval($_POST["session"]);

		if(get_transient('questions_counter'.$session)>=0){
			$temp_array=get_transient('answer_sheet'.$session);
			$temp_array[get_transient('questions_counter'.$session)+1]["correct"]=false;
			$temp2=explode("|", $_POST["answer"]);
			if(get_transient('answer'.$session)==$temp2){
				set_transient('questions_right'.$session, get_transient('questions_right'.$session)+1, 9999);
				$temp_array[get_transient('questions_counter'.$session)+1]["correct"]=true;
			}

			$temp_array[get_transient('questions_counter'.$session)+1]["question_id"]=get_transient('question_id'.$session);
			$temp_array[get_transient('questions_counter'.$session)+1]["answer"]=$_POST["answer"];
			set_transient('answer_sheet'.$session, $temp_array, 9999);
		}

		set_transient('questions_counter'.$session, get_transient('questions_counter'.$session)+1, 9999);
		if(get_transient('questions_counter'.$session)>get_transient('total_questions'.$session)-1 || $last) {
			exit_quiz($session, false);
		} else if (get_transient('all_questions'.$session)=="true") {
			all_questions($session);
			return;
		} else {
			if(get_transient('qrandom'.$session)) {
				if(!get_transient('qr'.$session)) {
					$random=range(1, get_transient('total_questions'.$session));
					shuffle($random);
					set_transient('qr'.$session, $random, 9999);
				} else {
					$random=get_transient('qr'.$session);
				}
				$question = $wpdb->get_row("SELECT * FROM ssquiz_questions WHERE quiz_id='".get_transient('quiz_id'.$session)."' AND number='". $random[get_transient('questions_counter'.$session)] . "'", ARRAY_A);
			} else
				$question = $wpdb->get_row("SELECT * FROM ssquiz_questions WHERE quiz_id='".get_transient('quiz_id'.$session)."' AND number='". (get_transient('questions_counter'.$session)+1) . "'", ARRAY_A);
		$answers = $wpdb->get_results("SELECT * FROM ssquiz_answers WHERE question_id='".$question['id']."'");
		$correct = $wpdb->get_var("SELECT COUNT(*) FROM ssquiz_answers WHERE question_id='".$question['id']."' AND correct='1'");
		
		//var_dump($question);
		if ($question== NULL) {
			echo '<script>document.getElementById("next_button").style.display="none";document.getElementById("exit_but").style.display="none";</script>';
			die("There is no tests in quiz <strong>". get_transient('quiz_title'.$session)."</strong>");
		}

		set_transient('question_id'.$session, $question["id"], 9999); 
		//set_transient('answer'.$session, $answer, 9999);
		echo '<div class="question"><strong>Question #';
		echo get_transient('questions_counter'.$session)+1; echo ':</strong><br  />'; 
		echo stripslashes(stripslashes(html_entity_decode($question["question"]))); 
		echo '</div><br  />';
		$temp=array();
        //--------checking for multianswer test
		//$myrows = $wpdb->get_col( "SELECT answer FROM ssquiz_answers WHERE question_id=" .  $question["id"] . "ORDER BY number");
		if(count($answers)>1) {
			//array_push($myrows, $question["answer"]);
			if(get_transient("arandom".$session)) 
				shuffle($answers);
			set_transient('answer'.$session, "", 9999);
			foreach($answers as $answer) {
				$answer=get_object_vars($answer);
				if($correct>1)
					echo '<input type="checkbox" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
				else
					echo '<input type = "radio" name="'.$question['id'].'" class="answer" value="'. $answer['answer'] .'">'. $answer['answer'] . '<br>';
					
				if($answer['correct']=='1')
					array_push($temp, $answer['answer']);
			}
			set_transient('answer'.$session, $temp, 9999);
		}
		else {
			echo '<input class="answer" value=""  />';
			//var_dump($answers);
			$answers=get_object_vars($answers[0]);
			array_push($temp, $answers['answer']);
			set_transient('answer'.$session, $temp, 9999);
		}
    }
	die();
}
add_action('wp_ajax_view_answer', 'view_answer');
add_action('wp_ajax_nopriv_view_answer', 'view_answer');
add_action('wp_ajax_exit_quiz', 'exit_quiz');
add_action('wp_ajax_nopriv_exit_quiz', 'exit_quiz');
add_action('wp_ajax_do_all', 'do_all');
add_action('wp_ajax_nopriv_do_all', 'do_all');
add_action('wp_ajax_start_quiz', 'start_quiz');
add_action('wp_ajax_nopriv_start_quiz', 'start_quiz');
add_action('wp_ajax_quiz_a', 'next_question');
add_action('wp_ajax_nopriv_quiz_a', 'next_question');
?>